-- Hauswirth
-- Bayn TSF3
-- Big thanks to guimchevalier for his script "Pince.lua"
-- 03-09-09


Hauswirth = {};

function Hauswirth.prerequisitesPresent(specializations)
    return SpecializationUtil.hasSpecialization(Trailer, specializations);
end;

function Hauswirth:load(xmlFile)	
	
	self.numAttachers = Utils.getNoNil(getXMLInt(xmlFile, "vehicle.Attachers#count"), 0);
	self.Attacher = {};
	
	for i=1, self.numAttachers do
	 self.Attacher[i] = {};
	 local partnamei = string.format("vehicle.Attachers.objectAttacher".."%d",i);
	 self.Attacher[i].object = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, partnamei .. "#index"));
	 setRigidBodyType(self.Attacher[i].coll,"none")
	 self.Attacher[i].attachedObject = nil;
	 self.Attacher[i].objectInRange = nil;
	end;
end;

function Hauswirth:getSaveAttributesAndNodes(nodeIdent)
    for i=1, self.numAttachers do
        ObjectDetachHauswirth(self,i)
    end;
   return nil, nil;
end;

function Hauswirth:delete()
			for i=1, self.numAttachers do
			ObjectDetachHauswirth(self,i)
			end;
end;

function Hauswirth:mouseEvent(posX, posY, isDown, isUp, button)
end;

function Hauswirth:keyEvent(unicode, sym, modifier, isDown)
end;

function Hauswirth:update(dt)
	if self:getIsActiveForInput() then
		if InputBinding.isPressed(InputBinding.HAUSWIRTHDETACH) then
			-- dcrochage
			for i=1, self.numAttachers do
			ObjectDetachHauswirth(self,i)
			end;
		end;

		if InputBinding.isPressed(InputBinding.HAUSWIRTHATTACH) then
			-- dtection ballot
			for i=1, self.numAttachers do
				nearest, index = ObjectInRangeHauswirth(self,i);
				self.Attacher[i].objectInRange = nearest;
				-- accrochage
				ObjectAttachHauswirth(self,i)
			end;

		end;
	end;
end;

function Hauswirth:draw()
	if self.attacherVehicle ~= nil then
		g_currentMission:addExtraPrintText(string.format("Touche %s/%s: Attach/Detach bales", InputBinding.getButtonKeyName(InputBinding.HAUSWIRTHATTACH), InputBinding.getButtonKeyName(InputBinding.HAUSWIRTHDETACH)));
	end;
end;

function ObjectInRangeHauswirth(self,k)
	local nearestObject
	local itemNode
	local index 
	local nearestDistance = 0.5;
	local objectCopy = self.Attacher[k].object;	
	local px, py, pz = getWorldTranslation(objectCopy);
	for i=1, table.getn(g_currentMission.itemsToSave) do
	    itemNode = g_currentMission.itemsToSave[i].node;
	    if getParent(g_currentMission.itemsToSave[i].node) == getRootNode() then
			if getUserAttribute(itemNode, "isStrawbale") or getUserAttribute(itemNode, "isHaybale") then
				local vx, vy, vz = getWorldTranslation(itemNode);
				local distance = Utils.vector3Length(px-vx, py-vy, pz-vz);
				if distance < nearestDistance then
					index = i
					nearestObject = itemNode
					nearestDistance = distance
					
				end;
			end;
		end;
	end;
	return nearestObject, index
end;

function ObjectAttachHauswirth(self,k)
	if self.Attacher[k].objectInRange ~= nil then
		if self.Attacher[k].attachedObject == nil then
			setRigidBodyType(self.Attacher[k].objectInRange,"none");
			local x,y,z = getWorldRotation(self.Attacher[k].objectInRange);		
			link(self.Attacher[k].object,self.Attacher[k].objectInRange);
			setRotation(self.Attacher[k].objectInRange, 0,0,0);
			setTranslation(self.Attacher[k].objectInRange, 0,0,0)
			self.Attacher[k].attachedObject = self.Attacher[k].objectInRange;
			self.Attacher[k].objectInRange = nil;
		end;
	end;
end;

function ObjectDetachHauswirth(self,k)
	if self.Attacher[k].attachedObject ~= nil then			
		local x,y,z = getWorldTranslation(self.Attacher[k].attachedObject)
		local rx,ry,rz = getWorldRotation(self.Attacher[k].attachedObject)
		local root = getRootNode()
		setTranslation(self.Attacher[k].attachedObject,x,y,z)
		setRotation(self.Attacher[k].attachedObject,rx,ry,rz)
		link(root,self.Attacher[k].attachedObject)
		setRigidBodyType(self.Attacher[k].attachedObject,"Dynamic")
		self.Attacher[k].attachedObject = nil;
	end;
end;